Object subclass: #Club
	instanceVariableNames: 'nombre tarifaSocio tarifaSocioVIP recaudacion socios'
	classVariableNames: ''
	package: 'tp0.5-Modelo'!

!Club methodsFor: 'as yet unclassified' stamp: 'LuisParedes 4/27/2020 21:28'!
establecerNombre: nombreClub
	nombre := nombreClub.! !

!Club methodsFor: 'as yet unclassified' stamp: 'LuisParedes 4/27/2020 21:06'!
establecerTarifaSocioVIP: unaTarifaSocioVIP
	tarifaSocioVIP := unaTarifaSocioVIP.! !

!Club methodsFor: 'as yet unclassified' stamp: 'LuisParedes 4/28/2020 13:36'!
cantidadPagadaPor: unSocio 
	|socio|
	socio := self obtenerSocio: unSocio.
	
	^ (socio obtenerCantPagos) * (self cantidadAPagar: socio).! !

!Club methodsFor: 'as yet unclassified' stamp: 'LuisParedes 4/27/2020 21:08'!
recaudacionTotal
	^ recaudacion! !

!Club methodsFor: 'as yet unclassified' stamp: 'LuisParedes 4/28/2020 13:58'!
recibirPagoDe: nombreSocio
	|socio|
	socio := self obtenerSocio: nombreSocio.
	
	socio registrarPago.
	recaudacion := recaudacion + (self cantidadAPagar: socio).
	
			! !

!Club methodsFor: 'as yet unclassified' stamp: 'LuisParedes 4/28/2020 13:28'!
nombresSocios
	^ ( socios collect: [ :socio | socio obtenerNombre ]  ) asSet.! !

!Club methodsFor: 'as yet unclassified' stamp: 'LuisParedes 4/28/2020 13:53'!
cantidadAPagar: unSocio 
	( (unSocio obtenerEstado) = 'socio' ) 
		ifTrue:[ ^ tarifaSocio ]
		ifFalse: [^ tarifaSocioVIP ].
		
! !

!Club methodsFor: 'as yet unclassified' stamp: 'LuisParedes 4/28/2020 13:26'!
cantidadDeSocios
	^ (socios size).! !

!Club methodsFor: 'as yet unclassified' stamp: 'LuisParedes 4/28/2020 13:24'!
agregarSocio: unSocio 
	unSocio establecerEstado: 'socio'.
	socios add: unSocio! !

!Club methodsFor: 'as yet unclassified' stamp: 'LuisParedes 4/28/2020 14:03'!
establecerTarifaSocio: unaTarifaSocio 
	tarifaSocio := unaTarifaSocio.! !

!Club methodsFor: 'as yet unclassified' stamp: 'LuisParedes 4/28/2020 13:43'!
agregarSocioVIP: unSocio
	unSocio establecerEstado: 'socio_VIP'.
	socios add: unSocio.! !

!Club methodsFor: 'as yet unclassified' stamp: 'LuisParedes 4/29/2020 17:49'!
obtenerSocio: nombreSocio
	^ (socios select: [ :socio | (socio obtenerNombre) = nombreSocio ]) first .! !


!Club methodsFor: 'initialization' stamp: 'LuisParedes 4/28/2020 13:26'!
initialize 
	nombre := String new.
	socios := LinkedList new.
	
	tarifaSocio := 0.
	tarifaSocioVIP := 0.
	recaudacion := 0.! !


Object subclass: #Socio
	instanceVariableNames: 'nombre cantPagos estado'
	classVariableNames: ''
	package: 'tp0.5-Modelo'!

!Socio methodsFor: 'as yet unclassified' stamp: 'LuisParedes 4/28/2020 12:42'!
registrarPago
	cantPagos := cantPagos + 1.! !

!Socio methodsFor: 'as yet unclassified' stamp: 'LuisParedes 4/28/2020 12:50'!
obtenerCantPagos
	^ cantPagos.! !

!Socio methodsFor: 'as yet unclassified' stamp: 'LuisParedes 4/28/2020 13:12'!
obtenerEstado
	^ estado.! !

!Socio methodsFor: 'as yet unclassified' stamp: 'LuisParedes 4/28/2020 13:13'!
establecerEstado: estadoSocio
	estado := estadoSocio.! !

!Socio methodsFor: 'as yet unclassified' stamp: 'LuisParedes 4/27/2020 21:27'!
establecerNombre: nombreSocio
	nombre := nombreSocio.! !

!Socio methodsFor: 'as yet unclassified' stamp: 'LuisParedes 4/28/2020 10:28'!
obtenerNombre
	^ nombre.! !


!Socio methodsFor: 'initialization' stamp: 'LuisParedes 4/28/2020 13:12'!
initialize 
	nombre := String new.
	estado := String new.
	cantPagos := 0.! !
